// Generated by delombok at Sun May 29 12:10:02 UTC 2016
package com.github.liblevenshtein.serialization;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.io.Serializable;
import lombok.NonNull;

/**
 * (De)Serializer for Java bytecode.
 */
@SuppressWarnings("unchecked")
public class BytecodeSerializer extends AbstractSerializer {
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  private static final org.slf4j.Logger log = org.slf4j.LoggerFactory.getLogger(BytecodeSerializer.class);

  /**
   * {@inheritDoc}
   */
  @Override
  public void serialize(@NonNull final Serializable object, @NonNull final OutputStream stream) throws Exception {
    if (object == null) {
      throw new java.lang.IllegalArgumentException("object is null");
    }
    if (stream == null) {
      throw new java.lang.IllegalArgumentException("stream is null");
    }
    log.info("Serializing an instance of [{}] to a stream", object.getClass());
    final ObjectOutputStream objectStream = new ObjectOutputStream(stream);
    objectStream.writeObject(object);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public byte[] serialize(@NonNull final Serializable object) throws Exception {
    if (object == null) {
      throw new java.lang.IllegalArgumentException("object is null");
    }
    log.info("Serializing an instance of [{}] to a byte array", object.getClass());
    try (ByteArrayOutputStream stream = new ByteArrayOutputStream()) {
      serialize(object, stream);
      return stream.toByteArray();
    }
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public <Type extends Serializable> Type deserialize(@NonNull final Class<Type> type, @NonNull final InputStream stream) throws Exception {
    if (type == null) {
      throw new java.lang.IllegalArgumentException("type is null");
    }
    if (stream == null) {
      throw new java.lang.IllegalArgumentException("stream is null");
    }
    log.info("Deserializing an instance of [{}] from a stream", type);
    final ObjectInputStream objectStream = new ObjectInputStream(stream);
    return (Type) objectStream.readObject();
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public <Type extends Serializable> Type deserialize(@NonNull final Class<Type> type, @NonNull final byte[] bytes) throws Exception {
    if (type == null) {
      throw new java.lang.IllegalArgumentException("type is null");
    }
    if (bytes == null) {
      throw new java.lang.IllegalArgumentException("bytes is null");
    }
    log.info("Deserializing an instance of [{}] from a byte array", type);
    try (InputStream stream = new ByteArrayInputStream(bytes)) {
      return deserialize(type, stream);
    }
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public java.lang.String toString() {
    return "BytecodeSerializer()";
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof BytecodeSerializer)) return false;
    final BytecodeSerializer other = (BytecodeSerializer) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof BytecodeSerializer;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public int hashCode() {
    int result = 1;
    return result;
  }
}
