// Generated by delombok at Sun May 29 12:10:02 UTC 2016
package com.github.liblevenshtein.transducer;

import java.io.Serializable;

/**
 * {@link Position}s are used to maintain a sorted, linked-list of positions
 * within {@link com.github.liblevenshtein.transducer.State}s.  They are sorted
 * to simplify and optimize various operations on the positions (like
 * subsumption and merging-in new positions).
 * @author Dylon Edwards
 * @since 3.0.0
 */
public class Position implements Serializable {
  private static final long serialVersionUID = 1L;
  /**
   * Reference to the next node in this linked-list.  The next node may be null
   */
  private Position next = null;
  /**
   * Index of the dictionary term represented by this coordinate.
   */
  private final int termIndex;
  /**
   * Number of accumulated errors at this coordinate.
   */
  private final int numErrors;

  /**
   * Whether this position should be treated specially, such as whether it
   * represents a tranposition, merge, or split.
   * @return Whether this position should be treated specially.
   */
  public boolean isSpecial() {
    return false;
  }

  /**
   * Reference to the next node in this linked-list.  The next node may be null
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public Position next() {
    return this.next;
  }

  /**
   * Index of the dictionary term represented by this coordinate.
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public int termIndex() {
    return this.termIndex;
  }

  /**
   * Number of accumulated errors at this coordinate.
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public int numErrors() {
    return this.numErrors;
  }

  /**
   * Reference to the next node in this linked-list.  The next node may be null
   * @return this
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public Position next(final Position next) {
    this.next = next;
    return this;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof Position)) return false;
    final Position other = (Position) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$next = this.next();
    final java.lang.Object other$next = other.next();
    if (this$next == null ? other$next != null : !this$next.equals(other$next)) return false;
    if (this.termIndex() != other.termIndex()) return false;
    if (this.numErrors() != other.numErrors()) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof Position;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $next = this.next();
    result = result * PRIME + ($next == null ? 43 : $next.hashCode());
    result = result * PRIME + this.termIndex();
    result = result * PRIME + this.numErrors();
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public java.lang.String toString() {
    return "Position(next=" + this.next() + ", termIndex=" + this.termIndex() + ", numErrors=" + this.numErrors() + ")";
  }

  @java.beans.ConstructorProperties({"termIndex", "numErrors"})
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public Position(final int termIndex, final int numErrors) {
    this.termIndex = termIndex;
    this.numErrors = numErrors;
  }
}
