// Generated by delombok at Sun May 29 12:10:02 UTC 2016
package com.github.liblevenshtein.transducer;

import java.io.Serializable;

/**
 * {@link SpecialPosition}s are used to maintain a sorted, linked-list of
 * positions within {@link com.github.liblevenshtein.transducer.State}s.  They
 * are sorted to simplify and optimize various operations on the positions (like
 * subsumption and merging-in new positions).
 * @author Dylon Edwards
 * @since 3.0.0
 */
public class SpecialPosition extends Position implements Serializable {
  private static final long serialVersionUID = 1L;

  /**
   * Builds a new {@link Position}, extended with some special operation (e.g.
   * transposition or merge-and-split).
   * @param termIndex Index of the dictionary term represented by this coordinate.
   * @param numErrors Number of accumulated errors at this coordinate.
   */
  public SpecialPosition(final int termIndex, final int numErrors) {
    super(termIndex, numErrors);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public boolean isSpecial() {
    return true;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public java.lang.String toString() {
    return "SpecialPosition(super=" + super.toString() + ")";
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof SpecialPosition)) return false;
    final SpecialPosition other = (SpecialPosition) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    if (!super.equals(o)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof SpecialPosition;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    result = result * PRIME + super.hashCode();
    return result;
  }
}
