// Generated by delombok at Sun May 29 12:10:02 UTC 2016
package com.github.liblevenshtein.transducer;

import java.io.Serializable;
import lombok.NonNull;

/**
 * This wrapper around {@link LazyTransducerCollection}, which handles all the
 * heavy lifting.
 *
 * @author Dylon Edwards
 * @param <DictionaryNode> Kind of nodes of the dictionary automaton.
 * @param <CandidateType> Kind of the spelling candidates returned from the
 * dictionary.
 * @since 2.1.0
 */
public class Transducer<DictionaryNode, CandidateType> implements ITransducer<CandidateType>, Serializable {
  private static final long serialVersionUID = 1L;
  /**
   * Attributes required for this transducer to search the dictionary.
   */
  @NonNull
  private TransducerAttributes<DictionaryNode, CandidateType> attributes;

  /**
   * {@inheritDoc}
   */
  @Override
  public Iterable<CandidateType> transduce(@NonNull final String term) {
    if (term == null) {
      throw new java.lang.IllegalArgumentException("term is null");
    }
    return transduce(term, attributes.maxDistance());
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public Iterable<CandidateType> transduce(@NonNull final String term, final int maxDistance) {
    if (term == null) {
      throw new java.lang.IllegalArgumentException("term is null");
    }
    return new LazyTransducerCollection<DictionaryNode, CandidateType>(term, maxDistance, attributes);
  }

  /**
   * Attributes required for this transducer to search the dictionary.
   * @return this
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public Transducer<DictionaryNode, CandidateType> attributes(@NonNull final TransducerAttributes<DictionaryNode, CandidateType> attributes) {
    if (attributes == null) {
      throw new java.lang.IllegalArgumentException("attributes is null");
    }
    this.attributes = attributes;
    return this;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof Transducer)) return false;
    final Transducer<?, ?> other = (Transducer<?, ?>) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$attributes = this.attributes();
    final java.lang.Object other$attributes = other.attributes();
    if (this$attributes == null ? other$attributes != null : !this$attributes.equals(other$attributes)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof Transducer;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $attributes = this.attributes();
    result = result * PRIME + ($attributes == null ? 43 : $attributes.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public java.lang.String toString() {
    return "Transducer(attributes=" + this.attributes() + ")";
  }

  @java.beans.ConstructorProperties({"attributes"})
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public Transducer(@NonNull final TransducerAttributes<DictionaryNode, CandidateType> attributes) {
    if (attributes == null) {
      throw new java.lang.IllegalArgumentException("attributes is null");
    }
    this.attributes = attributes;
  }

  /**
   * Attributes required for this transducer to search the dictionary.
   */
  @NonNull
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public TransducerAttributes<DictionaryNode, CandidateType> attributes() {
    return this.attributes;
  }
}
