// Generated by delombok at Sun May 29 12:10:02 UTC 2016
package com.github.liblevenshtein.transducer.factory;

import java.io.Serializable;
import java.util.Comparator;
import com.github.liblevenshtein.transducer.MergeFunction;
import com.github.liblevenshtein.transducer.Position;
import com.github.liblevenshtein.transducer.StateTransitionFunction;
import com.github.liblevenshtein.transducer.UnsubsumeFunction;

/**
 * Builds (and recycles) instances of {@link StateTransitionFunction}.
 * @author Dylon Edwards
 * @since 2.1.0
 */
public class StateTransitionFactory implements Serializable {
  private static final long serialVersionUID = 1L;
  /**
   * Compares Levenshtein-state positions.
   */
  private Comparator<Position> comparator;
  /**
   * Builds Levenshtein states.
   */
  private StateFactory stateFactory;
  /**
   * Builds position-transition functions.
   */
  private PositionTransitionFactory positionTransitionFactory;
  /**
   * Merges Levenshtein states together.
   */
  private MergeFunction merge;
  /**
   * Removes subsumed positions from Levenshtein states.
   */
  private UnsubsumeFunction unsubsume;

  /**
   * Builds a new state-transition function that only considers spelling
   * candidates no more than {@code maxDistance} errors from the query term.
   * @param maxDistance Maximum number of errors tolerated in transforming the
   * query term into the spelling candidate.
   * @param queryLength Length of the query term.
   * @return New state-transition function that only considers spelling
   * candidates within {@code maxDistance} errors from the query term.
   */
  public StateTransitionFunction build(final int maxDistance, final int queryLength) {
    return new StateTransitionFunction().comparator(comparator).stateFactory(stateFactory).transitionFactory(positionTransitionFactory).merge(merge).unsubsume(unsubsume).maxDistance(maxDistance).queryLength(queryLength);
  }

  /**
   * Compares Levenshtein-state positions.
   * @return this
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public StateTransitionFactory comparator(final Comparator<Position> comparator) {
    this.comparator = comparator;
    return this;
  }

  /**
   * Builds Levenshtein states.
   * @return this
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public StateTransitionFactory stateFactory(final StateFactory stateFactory) {
    this.stateFactory = stateFactory;
    return this;
  }

  /**
   * Builds position-transition functions.
   * @return this
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public StateTransitionFactory positionTransitionFactory(final PositionTransitionFactory positionTransitionFactory) {
    this.positionTransitionFactory = positionTransitionFactory;
    return this;
  }

  /**
   * Merges Levenshtein states together.
   * @return this
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public StateTransitionFactory merge(final MergeFunction merge) {
    this.merge = merge;
    return this;
  }

  /**
   * Removes subsumed positions from Levenshtein states.
   * @return this
   */
  @java.lang.SuppressWarnings("all")
  @edu.umd.cs.findbugs.annotations.SuppressFBWarnings(justification = "generated code")
  @javax.annotation.Generated("lombok")
  public StateTransitionFactory unsubsume(final UnsubsumeFunction unsubsume) {
    this.unsubsume = unsubsume;
    return this;
  }
}
